#pragma once
#include <vector>

using namespace std;

class ImgToHilbert
{
private:
	int Order;
	int State;
	unsigned int HInputX[32];
	unsigned int HInputY[32];
	unsigned long HIndex;

	int Power2[32];

	vector<vector<int>> I;
	vector<int> HI;
	vector<int> HPixels;

	int W, H;

	void DetermineOrder();
	void ConvertToHIndex(int x, int y);
	unsigned long GenerateHIndex();

	void SolveState0(int i, int j);
	void SolveState1(int i, int j);
	void SolveState2(int i, int j);
	void SolveState3(int i, int j);
	void AddToHIndex(int x, int y);

	void CovertToXY(int h, int& x, int& y);
	int DecodeState0(unsigned int a, unsigned int b, int& x, int& y);
	int DecodeState1(unsigned int a, unsigned int b, int& x, int& y);
	int DecodeState2(unsigned int a, unsigned int b, int& x, int& y);
	int DecodeState3(unsigned int a, unsigned int b, int& x, int& y);
public:
	ImgToHilbert(void);
	void SetImage(int wi, int he, vector<vector<int>> Img);
	void ToHilbert();
	vector<int> ReturnHilbertPixels() { return HPixels; }


	void DeSetImageResolution(int W, int H);
	void DeReturnMatrix(vector<int>& Y, vector<vector<int>>& M);
};

