#include "InverseFrequencies.h"
#include "AuxCompFunctions.h"
#include <algorithm>

#pragma warning (disable : 4996)

InverseFrequencies::InverseFrequencies()
{
	
}

bool my_cmp(ABCStruct a, ABCStruct b)
{
	// smallest comes first
	return a.f > b.f;
}

bool my_cmp1(ABCStruct a, ABCStruct b)
{
	// smallest comes first
	return a.f < b.f;
}

void InverseFrequencies::InitOriginal(vector<int> V)
{
	I = V;
	n = (int)V.size();
	vector<ABCStruct> S;
	S.resize(256);
	for (int i = 0; i < S.size(); i++)
	{
		S[i].f = S[i].offset = S[i].v = 0;
	}


	for (int i = 0; i < V.size(); i++)
	{
		S[V[i]].f++;
		S[V[i]].v = V[i];
	}


	ABCStruct a;
	ABC.clear();

	for (int i = 0; i < S.size(); i++)
		if (S[i].f != 0)
		{
			a.v = S[i].v;
			a.f = S[i].f;
			a.offset = 0;
			ABC.push_back(a);
		}

	for (int i = 0; i < ABC.size(); i++)
	{
		int j = 0;
		int flag = 1;
		while (flag)
			if (I[j] != ABC[i].v)
				j++;
			else
				flag = 0;
		ABC[i].offset = j;
	}
}


vector<int> InverseFrequencies::DoIFOriginal()
{

	vector<int> P;
	int j;
	int counter, ItemCounter;

	O.clear();

	for (int i = 0; i < ABC.size(); i++)
	{
		P.clear();

		j = ABC[i].offset;
		O.push_back(j);
		I[j] = VISITED;
		j++;
		counter = 0;
		ItemCounter = 1;
		while ((ItemCounter < ABC[i].f) && (j < I.size()))
		{
			if (I[j] != ABC[i].v)
			{
				if (I[j] != VISITED)
					counter++;
			}
			else
			{
				P.push_back(counter);
				counter = 0;
				ItemCounter++;
				I[j] = VISITED;
			}
			j++;
		}
		O.insert(O.end(), P.begin(), P.end());
	}

	return O;
}


vector<int> InverseFrequencies::DeIFOriginal(vector<ABCStruct>& Abc, vector<int>& I)
{

	O.clear();
	ABC.clear();
	ABC = Abc;
	n = 0;
	for (int i = 0; i < ABC.size(); i++)
		n += ABC[i].f;

	O.resize(n, EMPTY);


	int position;
	int counter;
	int j = 0;

	for (int i = 0; i < ABC.size(); i++)
	{
		position = I[j];
		O[position] = ABC[i].v;
		position++;
		j++;
		
		for (int k = 1; k < ABC[i].f; k++)
		{
			if (I[j] != 0)
			{
				counter = 0;
				while (counter < I[j])
				{

					if (O[position + counter] == EMPTY)
						counter++;
					else
						position++;
				}
				position += counter;

				while ((O[position] != EMPTY) && (position < O.size()))
					position++;

				if (position < O.size())
					O[position] = ABC[i].v;
				position++;
				j++;
			}
			else
			{
				while ((O[position] != EMPTY) && (position < O.size()))
					position++;
				if (position < O.size())
					O[position] = ABC[i].v;
				position++;
				j++;
			}
		}
//		j++;
	}
	return O;
}

////////////////////////////////////////////////////


void InverseFrequencies::Init(vector<int> V, int SortedDown)
{
	I = V;
	n = (int)V.size();
	vector<ABCStruct> S;
	S.resize(256);
	for (int i = 0; i < S.size(); i++)
	{
		S[i].f = S[i].offset = S[i].v = 0;
	}


	for (int i = 0; i < V.size(); i++)
	{
		S[V[i]].f++;
		S[V[i]].v = V[i];
	}


	ABCStruct a;
	ABC.clear();

	for (int i = 0; i < S.size(); i++)
		if (S[i].f != 0)
		{
			a.v = S[i].v;
			a.f = S[i].f;
			a.offset = 0;
			ABC.push_back(a);
		}
	if (SortedDown)
		sort(ABC.begin(), ABC.end(), my_cmp);
	else
		sort(ABC.begin(), ABC.end(), my_cmp1);

	for (int i = 0; i < ABC.size(); i++)
	{
		int j = 0;
		int flag = 1;
		while (flag)
			if (I[j] != ABC[i].v)
				j++;
			else
				flag = 0;
		ABC[i].offset = j;
	}
}

vector<int> InverseFrequencies::DoIF()
{
	
	vector<int> P;
	int j;
	int counter, ItemCounter;
	
	O.clear();

	for (int i = 0; i < ABC.size(); i++)
	{
		P.clear();

		j = ABC[i].offset;
		I[j] = VISITED;
		j++;
		counter = 0;
		ItemCounter = 1;
		while ((ItemCounter < ABC[i].f) && (j < I.size()))
		{
			if (I[j] != ABC[i].v)
			{
				if (I[j] != VISITED)
					counter++;
			}
			else
			{
				P.push_back(counter);
				counter = 0;
				ItemCounter++;
				I[j] = VISITED;
			}
			j++;
		}
		O.insert(O.end(), P.begin(), P.end());
		O.push_back(GUARD);
	}

 	return O;
}


vector<int> InverseFrequencies::DeIF(int n, vector<ABCStruct>& Abc, vector<int>& I)
{

	O.clear();
	ABC.clear();
	O.resize(n, EMPTY);
	ABC = Abc;


	int position;
	int counter;
	int j = 0;

	for (int i = 0; i < ABC.size(); i++)
	{
		position = ABC[i].offset;
		O[position] = ABC[i].v;
		position++;
		while ((I[j] != GUARD) && (j < I.size()))
		{
			if (I[j] != 0)
			{
				counter = 0;
				while (counter < I[j])
				{

					if (O[position + counter] == EMPTY)
						counter++;
					else
						position++;
				}
				position += counter;

				while ((O[position] != EMPTY) && (position < O.size()))
					position++;

				if (position < O.size())
					O[position] = ABC[i].v;
				position++;
				j++;
			}
			else
			{
				while ((O[position] != EMPTY) && (position < O.size()))
					position++;
				if (position < O.size())
					O[position] = ABC[i].v;
				position++;
				j++;
			}
		}
		j++;
	}
	return O;
}