#include "MTFWithIntegers.h"

#include <algorithm>
#include <vector>

MTFWithIntegers::MTFWithIntegers() 
{ 
	lowerBound = upperBound = 0; 
	ABC.clear();
	O.clear();
}



void MTFWithIntegers::Init(int l, int h)
// move data in the range [0, h-l] and fills ABC as 0,1,2,...h-l;
{

	lowerBound = l;
	upperBound = h;

	int delta = h - l;
	for (int i = 0; i <= delta; i++)
		ABC.push_back(i);

}


vector<int> MTFWithIntegers::DoMTF(vector<int> I)
{
	int i, j;
	int position;

	for (i = 0; i < (int)I.size(); i++)
		I[i] -= lowerBound;

	for (i = 0; i < (int)I.size(); i++)
	{
		position = 0;
		while (ABC[position] != I[i])
			position++;

		O.push_back(position);

		for (j = position; j > 0; j--)
			ABC[j] = ABC[j - 1];
		ABC[0] = I[i];
	}
	return O;
}


vector<int> MTFWithIntegers::DoDeMTF(vector<int> I)
{
	int i,j;
	int value;
	int position;
	for (i = 0; i < (int)I.size(); i++)
	{
		value = ABC[I[i]];
		position  = I[i];
		O.push_back(value);

		for (j = position; j > 0; j--)
			ABC[j] = ABC[j - 1];
		ABC[0] = value;
	}
	for (i = 0; i < (int)O.size(); i++)
		O[i] += lowerBound;
	return O;
}
