#include "MyRawImageData.h"
#include "AuxCompFunctions.h"

using namespace std;

#pragma warning (disable : 4996)

MyRawImageData::MyRawImageData()
{
	W = H = 0;
	InputImageData.clear();
	BatchIndex = 0;

}


void MyRawImageData::ClearInputImageData()
{

	for (int i = 0; i < (int)InputImageData.size(); i++)
		InputImageData[i].clear();
	InputImageData.clear();
}

void MyRawImageData::SetInputDataBW(int w, int h, vector<vector<int>> P)
{
	ClearInputImageData();

	InputImageData = P;
	W = w;
	H = h;
}

double MyRawImageData::ReturnEntropy()
{	
	return CalculateEntropy(DoMatrixStatistic(H, W, InputImageData));
}



char* MyRawImageData::GetPathAndName(char* S, const char* name)
{
	S[0] = '\0';
	strcpy(S, PATH_TO_IMAGES);
	strcat(S, name);
	return S;
}

int MyRawImageData::SelectImage()
{
	printf("  1...Baboon................... 17...Maltese\n");
	printf("  2...Ballons...................18...Man\n");
	printf("  3...Barb......................19...Mango\n");
	printf("  4...Barbara...................20...Mercury\n");
	printf("  5...Bark......................21...Monarch\n");
	printf("  6...Board.....................22...Mosaic\n");
	printf("  7...Boats.....................23...Mushrooms\n");
	printf("  8...Cameraman.................24...Parrots\n");
	printf("  9...Earth.....................25...Pens\n");
	printf(" 10...Flower....................26...Peppers\n");
	printf(" 11...Flowers...................27...Rainier\n");
	printf(" 12...Fruits....................28...Sailing\n");
	printf(" 13...Girl......................29...Sun\n");
	printf(" 14...Gold......................30...Sunrise\n");
	printf(" 15...Lena......................31...Yachts\n");
	printf(" 16...Malamute..................32...Zelda\n");
	printf("99...Exit\n");

	/*
	printf("  1...Baboon................... 18...Malamute\n");
	printf("  2...Ballons...................19...Maltese\n");
	printf("  3...Barb......................20...Man\n");
	printf("  4...Barbara...................21...Mango\n");
	printf("  5...Bark......................22...Mercury\n");
	printf("  6...Bicycle...................23...Monarch\n");
	printf("  7...Board.....................24...Mosaic\n");
	printf("  8...Boats.....................25...Mushrooms\n");
	printf("  9...Bridge....................26...Parrots\n");
	printf(" 10...Cameraman.................27...Pens\n");
	printf(" 11...Earth.....................28...Peppers\n");
	printf(" 12...Flower....................29...Rainier\n");
	printf(" 13...Flowers...................30...Sailing\n");
	printf(" 14...Fruits....................31...Sun\n");
	printf(" 15...Girl......................32...Sunrise\n");
	printf(" 16...Gold......................33...Yacht\n");
	printf(" 17...Lena......................34...Zelda\n");
	printf("  0...Batch\n"); */

//	printf(" 18...Malamute\n");
//	printf(" 19...Maltese\n");
//	printf(" 20...Man\n");
//	printf(" 21...Mango\n");
//	printf(" 22...Mercury\n");
//	printf(" 23...Monarch\n");
//	printf(" 24...Mosaic\n");
//	printf(" 25...Mushrooms\n");
//	printf(" 26...Parrots\n");
//	printf(" 27...Pens\n");
//	printf(" 28...Peppers\n");
//	printf(" 29...Rainier\n");
//	printf(" 30...Sailing\n");
//	printf(" 31...Sun\n");
//	printf(" 32...Sunrise\n");
//	printf(" 33...Yacht\n");
//	printf(" 34...Zelda\n");
//		printf("98...All images\n");
//	printf("99...Exit\n");


	scanf("%d", &ImageIndex);
	
	if (ImageIndex == 99) return ImageIndex;

	if (ImageIndex == 0) // BATCH
	{
		for (int i = 0; i < NO_OF_BATCH_IMAGES; i++)
			BatchImageName[i][0] = '\0';

		char  S[128];
		strcpy(BatchImageName[0], GetPathAndName(S, "Baboon.bmp"));
		strcpy(BatchImageName[1], GetPathAndName(S, "Balloons.bmp"));
		strcpy(BatchImageName[2], GetPathAndName(S, "Barb.bmp"));
		strcpy(BatchImageName[3], GetPathAndName(S, "Barbara.bmp"));
		strcpy(BatchImageName[4], GetPathAndName(S, "Bark.bmp"));
		strcpy(BatchImageName[5], GetPathAndName(S, "Board.bmp"));
		strcpy(BatchImageName[6], GetPathAndName(S, "Boats.bmp"));
		strcpy(BatchImageName[7], GetPathAndName(S, "Cameraman.bmp"));
		strcpy(BatchImageName[8], GetPathAndName(S, "Earth.bmp"));
		strcpy(BatchImageName[9], GetPathAndName(S, "Flower.bmp"));
		strcpy(BatchImageName[10], GetPathAndName(S, "Flowers.bmp"));
		strcpy(BatchImageName[11], GetPathAndName(S, "Fruits.bmp"));
		strcpy(BatchImageName[12], GetPathAndName(S, "Girl.bmp"));
		strcpy(BatchImageName[13], GetPathAndName(S, "Gold.bmp"));
		strcpy(BatchImageName[14], GetPathAndName(S, "Lena.bmp"));
		strcpy(BatchImageName[15], GetPathAndName(S, "Malamute.bmp"));
		strcpy(BatchImageName[16], GetPathAndName(S, "Maltese.bmp"));
		strcpy(BatchImageName[17], GetPathAndName(S, "Man.bmp"));
		strcpy(BatchImageName[18], GetPathAndName(S, "Mango.bmp"));
		strcpy(BatchImageName[19], GetPathAndName(S, "Mercury.bmp"));
		strcpy(BatchImageName[20], GetPathAndName(S, "Monarch.bmp"));
		strcpy(BatchImageName[21], GetPathAndName(S, "Mosaic.bmp"));
		strcpy(BatchImageName[22], GetPathAndName(S, "Mushrooms.bmp"));
		strcpy(BatchImageName[23], GetPathAndName(S, "Parrots.bmp"));
		strcpy(BatchImageName[24], GetPathAndName(S, "Pens.bmp"));
		strcpy(BatchImageName[25], GetPathAndName(S, "Peppers.bmp"));
		strcpy(BatchImageName[26], GetPathAndName(S, "Rainier.bmp"));
		strcpy(BatchImageName[27], GetPathAndName(S, "Sailing.bmp"));
		strcpy(BatchImageName[28], GetPathAndName(S, "Sun.bmp"));
		strcpy(BatchImageName[29], GetPathAndName(S, "Sunrise.bmp"));
		strcpy(BatchImageName[30], GetPathAndName(S, "Yacht.bmp"));
		strcpy(BatchImageName[31], GetPathAndName(S, "Zelda.bmp"));

		return ImageIndex;
	}


	ImageIndex--;
	for (int i = 0; i < NO_OF_IMAGES; i++)
		ImageName[i][0] = '\0';

	char  S[128];
	strcpy(ImageName[0], GetPathAndName(S, "Baboon.bmp"));
	strcpy(ImageName[1], GetPathAndName(S, "Balloons.bmp"));
	strcpy(ImageName[2], GetPathAndName(S, "Barb.bmp"));
	strcpy(ImageName[3], GetPathAndName(S, "Barbara.bmp"));
	strcpy(ImageName[4], GetPathAndName(S, "Bark.bmp"));
	strcpy(ImageName[5], GetPathAndName(S, "Board.bmp"));
	strcpy(ImageName[6], GetPathAndName(S, "Boats.bmp"));	
	strcpy(ImageName[7], GetPathAndName(S, "Cameraman.bmp"));
	strcpy(ImageName[8], GetPathAndName(S, "Earth.bmp"));
	strcpy(ImageName[9], GetPathAndName(S, "Flower.bmp"));
	strcpy(ImageName[10], GetPathAndName(S, "Flowers.bmp"));
	strcpy(ImageName[11], GetPathAndName(S, "Fruits.bmp"));
	strcpy(ImageName[12], GetPathAndName(S, "Girl.bmp"));
	strcpy(ImageName[13], GetPathAndName(S, "Gold.bmp"));
	strcpy(ImageName[14], GetPathAndName(S, "Lena.bmp"));
	strcpy(ImageName[15], GetPathAndName(S, "Malamute.bmp"));
	strcpy(ImageName[16], GetPathAndName(S, "Maltese.bmp"));
	strcpy(ImageName[17], GetPathAndName(S, "Man.bmp"));
	strcpy(ImageName[18], GetPathAndName(S, "Mango.bmp"));
	strcpy(ImageName[19], GetPathAndName(S, "Mercury.bmp"));
	strcpy(ImageName[20], GetPathAndName(S, "Monarch.bmp"));
	strcpy(ImageName[21], GetPathAndName(S, "Mosaic.bmp"));
	strcpy(ImageName[22], GetPathAndName(S, "Mushrooms.bmp"));
	strcpy(ImageName[23], GetPathAndName(S, "Parrots.bmp"));
	strcpy(ImageName[24], GetPathAndName(S, "Pens.bmp"));
	strcpy(ImageName[25], GetPathAndName(S, "Peppers.bmp"));
	strcpy(ImageName[26], GetPathAndName(S, "Rainier.bmp"));
	strcpy(ImageName[27], GetPathAndName(S, "Sailing.bmp"));
	strcpy(ImageName[28], GetPathAndName(S, "Sun.bmp"));
	strcpy(ImageName[29], GetPathAndName(S, "Sunrise.bmp"));
	strcpy(ImageName[30], GetPathAndName(S, "Yacht.bmp"));
	strcpy(ImageName[31], GetPathAndName(S, "Zelda.bmp"));

	return ImageIndex+1;
}


int MyRawImageData::LoadBMP()
{
	CImg<unsigned char> image;

	char BMPFileName[128];
	BMPFileName[0] = '\0';
	strcpy(BMPFileName, ImageName[ImageIndex]);


	cimg::exception_mode(0);
	try {
		image.load(BMPFileName);
	}
	catch (CImgException& e) {

		printf("CImg Library Error: %s", e.what());
		return 0;
	}

	int width = image.width();
	int height = image.height();

	int x, y;
	vector<vector<int>> PInfo;
	PInfo.resize(width);
	for (x = 0; x < width; x++)
		PInfo[x].resize(height);


	for (x = 0; x < width; x++)
		for (y = 0; y < height; y++)
		{
			PInfo[x][y] = (int)image(x, y, 0, 0);
		}

	SetInputDataBW(width, height, PInfo);

	CImgDisplay main_display(image);
	while (!main_display.is_closed())
	{
		if (main_display.button())
		{
			main_display.close();
			return 1;
		}
		main_display.wait();
	}

	return 1;
}



int MyRawImageData::ReturnNextBatchData(vector<vector<int>>& IB)
{
	if (BatchIndex < NO_OF_BATCH_IMAGES)
	{

		CImg<unsigned char> image;

		char BMPFileName[128];
		BMPFileName[0] = '\0';
		strcpy(BMPFileName, BatchImageName[BatchIndex]);


		cimg::exception_mode(0);
		try {
			image.load(BMPFileName);
		}
		catch (CImgException& e) {

			printf("CImg Library Error: %s", e.what());
			return 0;
		}

		int width = image.width();
		int height = image.height();

		int x, y;
		vector<vector<int>> PInfo;
		PInfo.resize(width);
		for (x = 0; x < width; x++)
			PInfo[x].resize(height);


		for (x = 0; x < width; x++)
			for (y = 0; y < height; y++)
			{
				PInfo[x][y] = (int)image(x, y, 0, 0);
			}

		SetInputDataBW(width, height, PInfo);

		IB = PInfo;
		BatchIndex++;
		return 1;
	}
	return 0;
}