#pragma once
#include <vector>
#include "CImg.h"

using namespace std;
using namespace cimg_library;


#define PATH_TO_IMAGES "D:\\Data\\RasterImages\\GrayScale\\BMP\\"
#define NO_OF_IMAGES 32
#define NO_OF_BATCH_IMAGES 32


class MyRawImageData
{
private:
	vector<vector<int>> InputImageData;
	char ImageName[NO_OF_IMAGES][128];
	char BatchImageName[NO_OF_BATCH_IMAGES][128];

	int W, H;

	int ImageIndex;
	int BatchIndex;

	void ClearInputImageData();
	char* GetPathAndName(char* S, const char* name);
public:



	MyRawImageData();
	void SetInputDataBW(int w, int h, vector<vector<int>> P);
	int ReturnWidth() { return W; }
	int ReturnHeight() { return H; }
	vector<vector<int>>& ReturnImageData() { return InputImageData; }

	int ReturnNextBatchData(vector<vector<int>>& Image);
	int ReturnNoOfBatches() { return NO_OF_BATCH_IMAGES; }

	double ReturnEntropy();

	int SelectImage();
	int LoadBMP();
};

